#include "AST.h"
#include "CodeContext.h"


CodeLiteralNode TryStmtNode::popState( "STATIC_REF(exception_state) = state.prior;" );


void TryStmtNode::emitStatement( CodeContext &context )
{
    CodeContext subcontext( context );
    subcontext << "  struct ExceptionState state;" << endCline
	       << "  state.prior = STATIC_REF(exception_state);" << endCline
	       << "  state.handling = 0;" << endCline
	       << "  TO_LOCAL(state.value) = NULL;" << endCline
	       << "  STATIC_REF(exception_state) = &state;" << endCline
	       << endCline
	       << "  if (!SETJMP( state.handler )) ";
    {
	CodeContext blockContext( subcontext );
	block()->codeGen( blockContext );
    }
    catches()->codeGen( subcontext );
    popState.codeGen( subcontext );
    finally()->codeGen( subcontext );
    subcontext << "if (nonNull(state.value)) toss( state.value );" << endCline;
}
