#include "AST.h"


TreeListNode *TreeListNode::clone() const
{
    TreeListNode *copy = new TreeListNode;

    *copy = *this;
    copy->children = new TreeNode*[_arity];
    memcpy(copy->children, children, _arity * sizeof(*children));

    return copy;
}


////////////////////////////////////////////////////////////////////////


void TreeNode::deepCloneChildren( TreeNode &copy ) const
{
  for (int sweep = arity(); sweep--; )
    copy.child( sweep, child( sweep )->deepClone() );
}


TreeListNode *TreeListNode::deepClone() const
{
  TreeListNode * const copy = new TreeListNode;
  *copy = *this;
  
  copy->children = new TreeNode*[_arity];
  deepCloneChildren( *copy );

  return copy;
}
