#include "AST.h"
#include "ArrayAccessSet.h"
#include "code-util.h"
#include "code.h"
#include "dominator.h"

// #define DEBUG_FREE DEBUG_PHASE_ENABLED("free")
#define DEBUG_FREE 1

void ForEachStmtNode::free()
{
  if (SR)
    delete SR;
  if (arrayAccesses)
    delete arrayAccesses;
  freeDomInfo(this);
  TreeNode::free();
}

void TreeNode::free()
{
  for (int i = arity(); i-- > 0; )
    child(i)->free();

  if (0) {
    if (DEBUG_FREE)
      cout << "DELETE " << oper_name() << " " << long2hexstring((long) this) <<
	endl;
    delete this;
  }
}

