#include "AST.h"
#include "solver.h"


void TypeNode::localIdenticalTo( const TypeNode &other ) const
{
  if (localInferable())
    solver().identicalTo( *this, other );
}


////////////////////////////////////////////////////////////////////////


void ArrayTypeNode::localIdenticalTo( const TypeNode &other ) const
{
  TypeNode::localIdenticalTo( other );
  elementType()->localIdenticalTo( *other.elementType() );
}


void MethodTypeNode::localIdenticalTo( const TypeNode &other ) const
{
  TypeNode::localIdenticalTo( other );
  returnType()->localIdenticalTo( *other.returnType() );
  paramTypes()->localIdenticalTo( *other.paramTypes() );
}


void TypeListNode::localIdenticalTo( TypeListNode &other ) const
{
  assert( arity() == other.arity() );
  
  for (unsigned sweep = arity(); sweep--; )
    child( sweep )->localIdenticalTo( *other.child( sweep ) );
}
