#include "AST.h"
#include "decls.h"
#include "solver.h"


void TypeNode::localStronglySubsumedBy( const TypeNode &greater ) const
{
  if (localInferable())
    solver().identicalTo( *this, greater );
}


////////////////////////////////////////////////////////////////////////


void ArrayTypeNode::localStronglySubsumedBy( const TypeNode &greater ) const
{
  TypeNode::localIdenticalTo( greater );
  
  if (greater.isArrayType())
    elementType()->localStronglySubsumedBy( *greater.elementType() );
  else
    elementType()->localConservative();
}
