#include <class_header.h>
#include <gc.h>
#include <java_array.h>
#include <java_array_methods.h>


java_array_header *java_array_alloc( Region pregion, int length, int elementSize, int atomicelements)
{
  const size_t size = sizeof(java_array_header) + elementSize * length;
  java_array_header *array;
  class_header *class_info;

  if (pregion)
    {
      array = (java_array_header *) ralloc( pregion, size );
      class_info = (struct class_header *) ralloc( pregion, sizeof(struct class_header) );
    }
  else
    {
      array = (java_array_header *) ti_malloc( size );
      class_info = (struct class_header *) ti_malloc( sizeof(struct class_header) );
    }
  
  class_info->category = JavaArray;
  array->header.class_info = class_info;
  array->length = length;
  array->size = elementSize;
  array->atomicelements = atomicelements;
  
  return array;
}

void java_array_free( java_array_header *array ) {
  ti_free(array->header.class_info);
  ti_free(array);
  }

java_array_header *java_array_build( int length, int elementSize, void *data, int atomicelements )
{
  java_array_header * const array = java_array_alloc( 0, length, elementSize, atomicelements );
  if (length > 0) {
    memcpy( array + 1, data, length * elementSize );
  }
  return array;
}
