#ifndef INCLUDE_TITANIUM_RUNTIME_MONITOR_MACROS_H
#define INCLUDE_TITANIUM_RUNTIME_MONITOR_MACROS_H

#include "monitor.h"
#include "titanium_monitor_t.h"


#ifdef HAVE_MONITORS
# define MONITOR_FETCH_CLASS( holder )  TO_GLOBAL( (holder), 0, &class_monitor )
/* holder is always global, but object might be local */
#define MONITOR_FETCH_INSTANCE_LOCAL(  holder, object )  TO_GLOBAL( (holder), MYPROC, &((object)->monitor) )
#define MONITOR_FETCH_INSTANCE_GLOBAL( holder, object )  FIELD_ADDR_GLOBAL( holder, object, monitor )
#else /* no monitors */
# define MONITOR_FETCH_CLASS( holder )
# define MONITOR_FETCH_INSTANCE_LOCAL(  holder, object )
# define MONITOR_FETCH_INSTANCE_GLOBAL( holder, object )
#endif /* no monitors */

#define MONITOR_LOCK(   holder )  monitorEnter( TO_LOCAL( holder ), TO_PROC( holder ) )
#define MONITOR_UNLOCK( holder )  monitorExit(  TO_LOCAL( holder ), TO_PROC( holder ) )


#endif /* !INCLUDE_TITANIUM_RUNTIME_MONITOR_MACROS_H */
