(defun initialize-buffer (nodes builder)
  (insert-c++-comment-prefix nodes builder)
  (insert "#include <iostream>\n"
	  "\n"
	  "#include \"AST.h\"\n"
	  "\n"
	  "\n"))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun defnode* (name parents fields methods states)
  (let* ((details (resolve-fields fields))
	 (flds (aref details 2))
	 (attrs (aref details 1)))
    (if attrs
	(progn (insert
		"\n"
		(format "void %s::print (ostream& os, unsigned depth) const\n" name)
		"{\n"
		(format "    indent(os, depth);\n")
		(format "    os << \"(%s\";\n" name)
		(format "    os << '<';\n")
		(format "    if(position().file) os << *position().file->name(); else os << \"unknown\";\n")
		(format "    os << ' ' << position().posn << ',' << (position().posn+1) << '>';\n"))
	       (loop for f in flds do
		     (cond ((equal (cadr f) "const string*")
			    (insert (format "    os << \" \\\"\" << *%s() << \"\\\"\";\n" 
					    (car f))))
			   ((or (equal (cadr f) "Common::Modifiers")
				(equal (cadr f) "Modifiers"))
			    (insert (format "    os << \" (\" << stringifyModifiers (%s()) << ')';\n"
					    (car f))))
			   ((or (list-type (cadr f))
				(and (symbolp (cadr f)) (string-match "Node" (symbol-name (cadr f)))))
			    (if (eq (car f) 'destination)
				(insert "    os << \"-*-\";\n")
			      (insert "    os << \"\\n\";\n"
				      (format "    %s()->print (os, depth + 1);\n" (car f)))))
			   ((and (stringp (cadr f)) (string-match "Decl\*" (cadr f)))
			    (insert "    os << \" \";\n"
				    (format "    %s()->print (os);\n" (basic-field-name (car f)))))
			   (t 
			    (insert (format "    os << \" \" << %s();\n" (car f))))))
	       (insert "    os << \")\";\n"
		       "}\n")))))
